-- Do not manually edit this file, it was auto-generated by dillonkearns/elm-graphql
-- https://github.com/dillonkearns/elm-graphql


module UsersApi.Scalar exposing (Codecs, UserId(..), defaultCodecs, defineCodecs, unwrapCodecs, unwrapEncoder)

import Graphql.Codec exposing (Codec)
import Graphql.Internal.Builder.Object as Object
import Graphql.Internal.Encode
import Json.Decode as Decode exposing (Decoder)
import Json.Encode as Encode


type UserId
    = UserId String


defineCodecs :
    { codecUserId : Codec valueUserId }
    -> Codecs valueUserId
defineCodecs definitions =
    Codecs definitions


unwrapCodecs :
    Codecs valueUserId
    -> { codecUserId : Codec valueUserId }
unwrapCodecs (Codecs unwrappedCodecs) =
    unwrappedCodecs


unwrapEncoder getter (Codecs unwrappedCodecs) =
    (unwrappedCodecs |> getter |> .encoder) >> Graphql.Internal.Encode.fromJson


type Codecs valueUserId
    = Codecs (RawCodecs valueUserId)


type alias RawCodecs valueUserId =
    { codecUserId : Codec valueUserId }


defaultCodecs : RawCodecs UserId
defaultCodecs =
    { codecUserId =
        { encoder = \(UserId raw) -> Encode.string raw
        , decoder = Object.scalarDecoder |> Decode.map UserId
        }
    }
